<!--
 * @Author: zhp
 * @Date: 2023-01-11 09:24:58
 * @LastEditTime: 2023-06-29 11:15:25
 * @LastEditors: zwq
 * @Description: 
-->
<template>
  <el-card shadow="never" class="aui-card--fill">
    <div class="mod-sys__user">
      <SearchBar :formConfigs="formConfig" ref="ruleForm" @headBtnClick="buttonClick">
        <!-- <el-badge :value="1" class="item">
          <el-button type="primary" size="small" @click="conditionSearch">条件搜索</el-button>
        </el-badge> -->
      </SearchBar>
      <base-table
        :table-props="tableProps"
        :page="listQuery.page"
        :limit="listQuery.limit"
        :table-data="tableData"
      >
        <method-btn
          v-if="tableBtn.length"
          slot="handleBtn"
          :width="150"
          label="操作"
          :method-list="tableBtn"
          @clickBtn="handleClick"
        />
      </base-table>
      <pagination
        :limit.sync="listQuery.limit"
        :page.sync="listQuery.page"
        :total="listQuery.total"
        @pagination="getDataList"
      />
      <!-- 弹窗, 新增 / 修改 -->
      <base-dialog
        :dialogTitle="addOrEditTitle"
        :dialogVisible="addOrUpdateVisible"
        @cancel="handleCancel"
        @confirm="handleConfirm"
        :before-close="handleCancel"
        width="70%"
      >
        <startEightDiscipline-add ref="addOrUpdate" @refreshDataList="successSubmit">
        </startEightDiscipline-add>
        <!-- <el-row slot="footer" type="flex" justify="end"> </el-row> -->
      </base-dialog>
    </div>
  </el-card>
</template>

<script>
import basicPage from "@/mixins/basic-page";
import startEightDisciplineAdd from "./components/startEightDiscipline-add";
// import AddOrUpdate from './params-add-or-update'
// import customSamplingSearch from "./components/customSamplingSearch"
// import available from "./components/available.vue"
import basicSearch from "@/mixins/basic-search";
import codeFilter from "@/filters/code-filter";
import { timeFormatter } from "@/filters/code-filter";
import i18n from "@/i18n";
const tableProps = [
  {
    prop: "title",
    label: i18n.t("code.title"),
    align: "center",
  },
  {
    prop: "code",
    label: i18n.t("code.code"),
    align: "center",
  },
  {
    prop: "eightDisciplineType",
    label: i18n.t("code.eightDisciplineType"),
    align: "center",
    filter: codeFilter("eightDisciplineType"),
  },
  {
    prop: "occurrenceDate",
    label: i18n.t("code.occurrenceDate"),
    align: "center",
    filter: timeFormatter,
  },
  // {
  //   prop: 'productName',
  //   label: i18n.t("code.productName"),
  //   align: 'center'
  // },
  // {
  //   prop: 'customName',
  //   label: i18n.t("code.customName"),
  //   align: 'center'
  // },
  {
    prop: "description",
    label: i18n.t("code.description"),
    align: "center",
  },
  {
    prop: "examineStatus",
    label: i18n.t("code.examineStatus"),
    align: "center",
    filter: codeFilter("examineStatus"),
  },
];
const tableBtn = [
  {
    type: "edit",
    btnName: "编辑",
  },
  {
    type: "delete",
    btnName: "删除",
  },
  {
    type: "CAR",
    btnName: "启动CAR",
  },
];
export default {
  mixins: [basicPage, basicSearch],
  components: {
    // customSamplingSearch,
    startEightDisciplineAdd,
  },
  data() {
    return {
      urlOptions: {
        getDataListURL: "/code/startEightDiscipline/page",
        deleteURL: "/code/startEightDiscipline",
      },
      tableProps,
      tableBtn,
      searchOrEditTitle: "",
      searchOrUpdateVisible: false,
      formConfig: [
        {
          type: "input",
          label: i18n.t("code.title"),
          placeholder: i18n.t("code.title"),
          param: "title",
        },
        // {
        //   type: "",
        //   label: i18n.t("params.paramCode"),
        //   placeholder: i18n.t("params.paramCode"),
        //   param: "paramCode",
        // },
        // {
        //   type: "separate",
        // },
        {
          type: "button",
          btnName: "搜索",
          name: "search",
          color: "primary",
        },
        {
          type: "button",
          btnName: "新增",
          name: "add",
          color: "primary",
        },
      ],
      listQuery: {
        limit: 10,
        page: 1,
        total: 1,
        eightDisciplineStatus: 0,
        examineStatus: 0
      },
    };
  },
  // components: {
  //   AddOrUpdate,
  // },
  methods: {
    //search-bar点击
    handleProductCancel() {
      this.productOrUpdateVisible = false;
      this.productOrEditTitle = "";
    },
    // handleSearchCancel() {
    //   this.searchOrEditTitle = "";
    //   this.searchOrUpdateVisible = false;
    // },
    conditionSearch() {
      this.searchOrEditTitle = "搜索";
      this.searchOrUpdateVisible = true;
      this.$nextTick(() => {
        this.$refs.searchOrUpdate.init();
      });
    },
    conditionSearchSubmit(dataForm) {
      // console.log(key);
      // console.log(key);
      // this.listQuery.key = key;
      this.listQuery.customSamplingCode = dataForm.customSamplingCode;
      // this.listQuery.name = dataForm.name
      // this.listQuery.failureTypeStatus = dataForm.failureTypeStatus
      this.listQuery.page = 1;
      this.getDataList();
      this.searchOrUpdateVisible = false;
      // console.log(11111);
      // this.conditionSearchSubmit();
    },
    handleClick(val) {
      console.log(val);
      if (val.type === "delete") {
        this.$confirm(`确定对[名称=${val.data.failureTypeName}]进行删除操作?`, "提示", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning",
        })
          .then(() => {
            this.$http
              .delete(this.urlOptions.deleteURL, { data: [val.data.id] })
              .then(({ data }) => {
                if (data && data.code === 0) {
                  this.$message({
                    message: "操作成功",
                    type: "success",
                    duration: 1500,
                    onClose: () => {
                      this.getDataList();
                    },
                  });
                } else {
                  this.$message.error(data.msg);
                }
              });
          })
          .catch(() => {});
      } else if (val.type === "edit") {
        this.addOrUpdateVisible = true;
        this.addOrEditTitle = this.$t("edit");
        this.$nextTick(() => {
          this.$refs.addOrUpdate.init(val.data.id);
        });
      } else if (val.type === "CAR") {
        this.$confirm(`确定对此条数据进行启动CAR操作?`, "提示", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning",
        })
          .then(() => {
            let putData = {
              eightDisciplineStatus: 1,
              examineStatus: 1,
              id: val.data.id,
            };
            this.$http.put("/code/startEightDiscipline", putData).then(({ data }) => {
              if (data && data.code === 0) {
                this.$message({
                  message: "操作成功",
                  type: "success",
                  duration: 1500,
                  onClose: () => {
                    this.getDataList();
                  },
                });
              } else {
                this.$message.error(data.msg);
              }
            });
          })
          .catch(() => {});
      }
    },
    buttonClick(val) {
      switch (val.btnName) {
        case "search":
          // this.listQuery.paramCode = val.paramCode;
          this.listQuery.page = 1;
          this.listQuery.title = val.title ? val.title : "";
          this.listQuery.failureTypeStatus = null;
          this.listQuery.eightDisciplineStatus = 0;
          this.getDataList();
          break;
        case "add":
          this.addOrEditTitle = this.$t("add");
          this.addOrUpdateVisible = true;
          this.addOrUpdateHandle();
          break;
        default:
          console.log(val);
      }
    },
  },
};
</script>
